<%@ Page Language="C#" 
    MasterPageFile="~/Resources/MasterPages/Application.Master"
    CodeBehind="Deploy.aspx.cs" 
    Inherits="Inedo.BuildMaster.Web.WebApplication.Applications.Configuration.Deploy" 
    Title="Deploy Configuration File" %>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">

    <h1><%= HttpUtility.HtmlEncode(Title) %></h1>
    <div class="subH1">&nbsp;</div>
    
    <asp:PlaceHolder runat="server" ID="phFileDeployed" Visible="false">
        <bm:InfoBox runat="server" ID="ctlFileDeployed" BoxType="Success" />
        <bm:HyperLinkButton runat="server"
            ID="hlDone"
            NavigateUrl="Overview.aspx"
            Text="Done" />
    </asp:PlaceHolder>

    
    <asp:PlaceHolder runat="server" ID="phForm">
        <div class="white-box padded-box">
        <bm:FormFieldGroup runat="server" ID="ctlRelease">
            <Description Heading="Release Number">
                The release number of the associated configuration file, and whether to force the configuration file instance to use the most recently created template instead of the template for the selected release.
            </Description>
            <FormFields>
                <bm:StandardFormField LabelText="Release Number:">
                    <FieldContent>
                        <asp:DropDownList runat="server" ID="ddlReleaseNumber" AutoPostBack="true" OnSelectedIndexChanged="ddlReleaseNumber_SelectedIndexChanged" />
                    </FieldContent>
                </bm:StandardFormField>                
                <bm:StandardFormField LabelText="">
                    <FieldContent>
                        <asp:CheckBox runat="server" ID="chkForceCurrentTemplate" Text="Force most recent template" AutoPostBack="true" OnCheckedChanged="chkForceCurrentTemplate_CheckChanged" />
                    </FieldContent>
                </bm:StandardFormField>                
            </FormFields>
        </bm:FormFieldGroup>
        
        <bm:FormFieldGroup runat="server" ID="ctlServerFormFieldGroup">
            <Description Heading="Server">
                The server where the configuration file will be deployed.
            </Description>
            <FormFields>
                <bm:StandardFormField LabelText="Server:">
                    <FieldContent>
                        <asp:DropDownList runat="server" ID="ddlServers" OnSelectedIndexChanged="ddlServer_SelectedIndexChanged" AutoPostBack="true" />
                    </FieldContent>
                </bm:StandardFormField>                
            </FormFields>
        </bm:FormFieldGroup>
        
        <bm:FormFieldGroup runat="server" ID="ctlDeployToLocationFieldGroup">
            <Description Heading="Deploy to Location">
                The absolute path where the file should be deployed on disk. If no file name is specified,
                the configuration file's name will be used.
            </Description>
            <FormFields>
                <bm:StandardFormField LabelText="Directory:">
                    <FieldContent>
                        <bm:SourceControlFileFolderPicker runat="server" ID="ctlFileLocation" Required="true" />
                        <div runat="server" id="divLastDeployed" class="subLabel" style="word-wrap: break-word;width:300px;cursor:hand; cursor:pointer;" />
                    </FieldContent>
                </bm:StandardFormField>
                <bm:StandardFormField LabelText="File Name:">
                    <FieldContent>
                        <bm:ValidatingTextBox runat="server" ID="txtFileName" DefaultText="(default)" />
                    </FieldContent>
                </bm:StandardFormField>
            </FormFields>
        </bm:FormFieldGroup>

        <bm:FormFieldGroup runat="server" ID="ctlInstanceNameFieldGroup">
            <Description Heading="Instance Name">
                The instance name of the configuration file you want to deploy.
            </Description>
            <FormFields>
                <bm:StandardFormField LabelText="Instance Name:">
                    <FieldContent>
                        <asp:DropDownList runat="server" ID="ddlInstance" Width="150" OnSelectedIndexChanged="ddlInstance_SelectedIndexChanged" AutoPostBack="true" />
                        <bm:StyledRequiredFieldValidator runat="server"
                            ID="rfv_ddlInstance" 
                            ControlToValidate="ddlInstance" 
                            InitialValue="" />
                        <noscript>
                            <asp:Button runat="server"
                                Text="Load Versions"
                                OnClick="ddlInstance_SelectedIndexChanged"
                                CssClass="buttonMinor" />
                        </noscript>
                    </FieldContent>
                </bm:StandardFormField>                
            </FormFields>
        </bm:FormFieldGroup>
        
        <bm:FormFieldGroup runat="server" ID="ctlVersionFormFieldGroup" EndGroup="true">
            <Description Heading="Version">
                The version of the configuration file you want to deploy.
            </Description>
            <FormFields>
                <bm:StandardFormField LabelText="Version:">
                    <FieldContent>
                        <asp:DropDownList runat="server" ID="ddlVersion" Width="300" OnSelectedIndexChanged="ddlVersion_SelectedIndexChanged" AutoPostBack="true" />
                        <bm:StyledRequiredFieldValidator runat="server"
                            ID="rfv_ddlVersion" 
                            ControlToValidate="ddlVersion" 
                            InitialValue="" />                    
                    </FieldContent>
                </bm:StandardFormField>                
            </FormFields>
        </bm:FormFieldGroup>
        </div>
        
        <div class="action-button-container">
        
        <asp:Button runat="server"
            ID="btnDeploy"
            OnClick="btnDeploy_Click"
            Text="Deploy Configuration File"
            CssClass="button" />

        </div>

         <div style="margin-top: 20px;">
            <bm:BuildMasterStyledTable runat="server" ID="tblPreview"/>
         </div>
    </asp:PlaceHolder>
    
</asp:Content>
